<template>
  <div
    class="profile_resources card"
    :class="{disabled: disableCard}">
    <div class="profile_resources-header">
      <div class="profile_resources-header-title">
        {{$t('profile.sendEos.title')}}
      </div>
      <div class="profile_resources-header-func">
        <v-popover
          offset="16"
          placement="left">
          <img
            class="profile-info"
            src="~/static/icons/information.png"
            alt="">
          <template slot="popover">
            {{$t('helpers.sendeos')}}
          </template>
        </v-popover>
      </div>
    </div>
    <div class="profile_resources-inner">
      <div class="profile_resources-body">
        <div>
          <div>
            {{$t('common.from')}}: <span class="color-accent-light">
                    <span v-if="accountName === 'No account'">{{$t("common.noAccount")}}</span><span v-else>{{accountName}}</span>
                  </span>
          </div>
          <div>
            <div class="mt-10 mb-10">{{$t('profile.sendEos.to')}}:</div>
            <BInput
              :placeholder="$t('profile.sendEos.placeholder_account')"
              v-model="eosaddress"
              color="#00bac3"></BInput>
          </div>
          <div>
            <div class="mt-10 mb-10">Memo:</div>
            <BInput
              :placeholder="$t('profile.sendEos.placeholder_memo')"
              v-model="memo"
              color="#00bac3"></BInput>
          </div>
        </div>
        <div class="card myBets">
          <div class="myBets_body">
            <div class="flex flex-center myBets_body-values light_slider">
              <AmountInput
                :disabledInput="false"
                @input="changeInput"
                @change="changeAmount"
                :value="amount"
                :step="step"></AmountInput>
            </div>
            <div class="flex flex-between">
              <div class="light_slider-amount">{{min}} EOS</div>
              <div class="light_slider-amount">{{max}} EOS</div>
            </div>
            <div class="flex flex-center myBets_body-slider">
              <div class="flex flex-middle">
                <div class="progress"></div>
              </div>
              <BSlider
                v-model="amount"
                :zeroBlock="zeroBlock"
                :min="min"
                :max="max"
                :step="step"
                label="EOS"></BSlider>
            </div>
          </div>
        </div>
      </div>
      <div class="profile_resources-slider-btn flex flex-center">
        <Btn
          :loading="loading"
          backgroundColor="#42d465"
          @click="submit">{{$t('profile.send')}}
        </Btn>
      </div>
    </div>
    <TheModal ref="modal"></TheModal>
    <TheAdditionalResources
      ref="resourcesModal"
      @submit="submit"></TheAdditionalResources>
  </div>
</template>

<script>
  import AmountInput from '~/components/UI/AmountInput';
  import BSlider from '~/components/UI/Slider/';
  import Btn from '~/components/UI/BtnSign';
  import BInput from '~/components/UI/Input';
  import notification
    from '~/components/UI/Notification/main.js';
  import TheModal from './TheModal';
  import TheAdditionalResources from './TheAdditionalResourcesModal';
  import {flooring} from "~/components/utils";

  export default {
    name: "index",
    data() {
      return {
        loading: false,
        zeroBlock: 10,
        amount: 1,
        min: 0.1,
        max: 100,
        step: 0.1,
        eosaddress: '',
        memo: '',
      }
    },
    components: {
      AmountInput,
      BSlider,
      Btn,
      BInput,
      TheModal,
      TheAdditionalResources
    },
    computed: {
      balance() {
        return this.$store.state.wallet.balance;
      },
      accountName() {
        return this.$store.state.wallet.accountName;
      },
      disableCard() {
        return (this.$store.state.common.demo || this.$store.state.wallet.accountName === 'No account');
      },
    },
    methods: {
      checkValue(val) {
        if(val + this.amount > 1) {
          val = flooring(val*10);
        }
        return val;
      },
      changeInput(val) {
        val = Math.abs(val);
        this.min = Math.min(val, this.step);
        console.log("change amount", val, this.min);
        this.amount= parseFloat((val).toFixed(2));
      },
      changeAmount(val) {
        val = this.checkValue(val);
        if(this.amount+val > 0) {
          this.min = Math.min(flooring(this.amount + val), this.step);
          this.amount= parseFloat((this.amount+val).toFixed(2));
        }
      },
      async submit(resourcesPrice=0) {
        if (this.balance <= 0) {
          return notification.info({
            message: this.$t('profile.sendEos.lowBalance'),
          });
        }
        if (this.amount < this.min) {
          return this.amount = this.min;
        }
        if (this.amount > this.balance) {
          return this.amount = this.balance;
        }
        if(resourcesPrice > 0) {
          if(this.balance < this.amount + resourcesPrice) {
            this.amount = this.amount - (this.amount + resourcesPrice - this.balance);
          }
        }


        this.loading = true;
        const [err, res] = await this.$store.dispatch('wallet/transfer', {
          toAccount: this.eosaddress,
          amount: (this.amount).toFixed(4) + ' EOS',
          memo: this.memo
        });
        if (!err) {
          this.$refs['resourcesModal'].cancel();
          notification.success({
            message: 'Transaction has been sent successfully',
          });
          this.$refs['modal'].txid = res.transaction_id;
          this.$refs['modal'].component.show();
          this.$refs['resourcesModal'].disabled = false;
        } else {
          const res = this.$refs['resourcesModal'].show(err.message);
          if (res) {
            this.$refs['resourcesModal'].disabled = false;
            notification.warning({
              message: res,
            });
          } else {
            this.$refs['resourcesModal'].disabled = false;
            notification.info({
              message: 'Please buy additional resources',
            });
          }
        }
        this.loading = false;
      }
    }
  }
</script>
<style lang="scss">
  .light_slider {
    &-amount {
      font-size: .725rem;
      &:first-child {
        color: rgba(255, 255, 255, .6);
        margin-left: 10px;
      }
      &:last-child {
        color: rgba(255, 255, 255, 1);
        margin-right: 10px;
      }
    }
  }
</style>
